clearvars -except timerS own_machine_performance; clc; close all;

% la1 = 1.5;
% la2 = 1.5;
la1 = 0.5;
la2 = 0.5;
la = [la1,la2];
nu1 = 0.05;
zeta2 = 0.25; amax_s = 1;


I=30;
amin = 0;
amax = 1.05;
a = linspace(amin,amax,I)';
da = (amax-amin)/(I-1);

aa = [a,a];

Aswitch = [-speye(I)*la(1),speye(I)*la(1);speye(I)*la(2),-speye(I)*la(2)];


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% KFE WITH APPROXIMATE SAVING POLICIES %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
adot(:,1) = -sqrt(2*nu1*a);
adot(:,2) = zeta2*(amax_s - a);
plot(a,adot)



%%%%%%%%%%%%%%%%%%%%%%%%%
% NUMERICAL SOLN TO KFE %
%%%%%%%%%%%%%%%%%%%%%%%%%

%CONSTRUCT MATRIX
X = - min(adot,0)/da;
Y = - max(adot,0)/da + min(adot,0)/da;
Z = max(adot,0)/da;

A1=spdiags(Y(:,1),0,I,I)+spdiags(X(2:I,1),-1,I,I)+spdiags([0;Z(1:I-1,1)],1,I,I);
A2=spdiags(Y(:,2),0,I,I)+spdiags(X(2:I,2),-1,I,I)+spdiags([0;Z(1:I-1,2)],1,I,I);

A = [A1,sparse(I,I);sparse(I,I),A2] + Aswitch;
AT = A';
b = zeros(2*I,1);

%need to fix one value, otherwise matrix is singular
i_fix = 1;
b(i_fix)=.1;
row = [zeros(1,i_fix-1),1,zeros(1,2*I-i_fix)];
AT(i_fix,:) = row;

%Solve linear system
gg = AT\b;
g_sum = gg'*ones(2*I,1)*da;
gg = gg./g_sum;

g = [gg(1:I),gg(I+1:2*I)];
G = cumsum(g*da);


%%%%%%%%%%%%%%%%%%%%%%%
% CLOSED-FORM FOR KFE %
%%%%%%%%%%%%%%%%%%%%%%%
F = exp(la1/sqrt(nu1/2)*sqrt(a - amin)).*((amax_s - a)./(amax_s - amin)).^(la2/zeta2);
integrand = F./adot(:,2);
M1tilde = la2*sum(integrand(a<=amax_s)*da);
M1 = la2/(la1+la2)*(1/M1tilde);

ka1 = -la1*M1; ka2 = la1*M1;

g_cf(:,1) = ka1./adot(:,1).*F; 
g_cf(:,2) = ka2./adot(:,2).*F;
g_cf(a>amax_s,:)=0;
g_cf = min(g_cf,1000);

M1
sum(g_cf(2:I,1)*da) + M1
sum(g_cf(:,2)*da)

error = (g_cf-g)*da;
plot(a,error)

%Plot sizes
FigureSize = [20 16];
lineWidth = 2;

figure(1)
plot(a,g_cf,a,g, 'LineWidth', lineWidth)
set(gca,'FontSize',14)
legend('g_1(a), Closed Form',...
    'g_2(a), Closed Form','g_1(a), Numerical Solution',...
    'g_2(a), Numerical Solution')
xlabel('Wealth, a', 'FontSize',18)
ylabel('Densities, g_j(a)', 'FontSize',18)
xlim([0 1.1])
ylim([0 3])
set(gcf,'Position', [3 3, FigureSize])
set(gcf,'PaperSize', FigureSize)
print -depsc ../Figures/Figure15a.eps

for i=1:I
    counter_cdf(i)=sum(g_cf(i:I,1)*da);
end
counter_cdf(1)=la2/(la1+la2);
G_cf(:,1) = la2/(la1+la2)-counter_cdf;
G_cf(:,2) = cumsum(g_cf(:,2)*da);

figure(2)
plot(a,G_cf,a,G, 'LineWidth', lineWidth)
xlabel('Wealth, a','FontSize',18)
ylabel('CDF, G_j(a)','FontSize',18)
xlim([-0.1 1])
ylim([0 0.6])
set(gcf,'Position', [3 3, FigureSize])
set(gcf,'PaperSize', FigureSize)
print -depsc ../Figures/Figure15b.eps


