%% Generate paper's figures
%Run in Matlab2019b

%% Initiate
%start timer
timerS = tic;

%Set to 1 in order to obtain the performance 
%of the algorithm in your own machine
%(used for figures 9 and 11).
own_machine_performance = 0;
%Otherwise it will use the run 
%presented in the paper, 
%whose results are stored in Data/plot_data_manuscript.txt.

%clean workspace
clearvars -except timerS own_machine_performance; clc; close all;

%set directory to current folder
cd(pwd)

%set default options for plots
set(groot ...
    ,'DefaultLegendAutoUpdate', 'off' ...    %remove auto-legend  
    ,'DefaultFigureUnits', 'centimeters' ... %to set size to display
    ,'DefaultFigurePaperUnits', 'centimeters' ...  %to set size to save      
    );                                

%% Figures for manuscript
%figures 1, 6 and 7
run('fig1_6_7.m')

%figures 2 and 3
run('fig2_3.m')

%figures 4
run('fig4.m')

%figures 5
run('fig5.m')

%figures 8
run('fig8.m')

%figures 9 and 11
run('fig9_11.m')

%figures 10
run('fig10.m')

%% Figures for appendix
%figures 12
run('fig12.m')

%figures 13
run('fig13.m')

%figures 14
run('fig14.m')

%figures 15
run('fig15.m')

%figures 16
run('fig16.m')

%figures 17
run('fig17.m')

%figures 18
run('fig18.m')

%% The end
%clean workspace
clearvars -except timerS own_machine_performance; clc; close all;

%success message
fprintf('All figures stored in the "Figures" folder.\n\n')

%end timer
toc(timerS)


